#include<bits/stdc++.h>
using namespace std;
#define ll long long
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //vrlo sam lenj i samo zelim bodove
    unordered_set<ll> kalkulacije;
    ll t;
    cin>>t;
    vector<ll> brojevi;
    while(t--){
        ll temp;
        cin>>temp;
        brojevi.push_back(temp);
    }
    sort(brojevi.begin(), brojevi.end());
    ll najdaljiBroj = 0;
    ll nadjenihUnikatnihZaNajdalji = 0;
    for(ll i = 0; i<brojevi.size(); i++){
        ll rez = 0;
        for(ll j = najdaljiBroj+1; j<=brojevi[i]; j++){
            ll produkt = 1;
            ll tempJ = j;
            while(tempJ){
                produkt*=tempJ%10;
                tempJ = tempJ/10;
            }
            if(!kalkulacije.count(produkt)){
                kalkulacije.insert(produkt);
                rez++;
            }

        }
        najdaljiBroj = brojevi[i];
        nadjenihUnikatnihZaNajdalji += rez;
        cout<<nadjenihUnikatnihZaNajdalji<<"\n";
    }
    return 0;
}